package require nsmcrypt

set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -base64 $td "MDEyMzQ1="
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out base64 $td "foofoo"]
ns_mcrypt flush $td 
ns_mcrypt destroy $td
puts $ctxt



set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -random $td 
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out raw $td "foofoo"]
ns_mcrypt flush $td 
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in raw -out str $td $ctxt]
ns_mcrypt destroy $td
puts $ptxt


set td [ns_mcrypt new "rijndael-256" "ncfb"]
ns_mcrypt initvector set -hex $td "ab325897ffde"
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out hex $td "foofoo"]
ns_mcrypt flush $td 
puts "cipher text (hex string): $ctxt"
set detachid [ns_mcrypt detach $td]
set test_test $detachid
set id $test_test
set td [ns_mcrypt attach $id]
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in hex -out raw $td $ctxt]
ns_mcrypt destroy $td
puts "plain decrypted text: $ptxt"

set td [ns_mcrypt new "rijndael-256" "cfb"]
ns_mcrypt initvector set -random $td 
ns_mcrypt init $td "foo"
set ctxt ""
set buf [ns_mcrypt crypt -in raw -out hex $td "foo1"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo2"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo3"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo4"]
append ctxt $buf
puts "cipher text (hex string): $ctxt"
ns_mcrypt flush $td 
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in hex -out str $td $ctxt]
ns_mcrypt destroy $td
puts "plain decrypted text: $ptxt"

