package require nsmcrypt

puts [ns_mcrypt algorithms]


puts [ns_mcrypt capability -algo  "rijndael-256"]


set td [ns_mcrypt new "rijndael-256" "ncfb"]
ns_mcrypt initvector set -hex $td "303132333435"
set iv [ns_mcrypt initvector get -base64 $td]
puts $iv
ns_mcrypt destroy $td

set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -random $td
ns_mcrypt init $td "keyword"
set txt [ns_mcrypt crypt -in raw -out hex $td "plaintext test"]
puts "crypt text (hex string): $txt"
ns_mcrypt flush $td 
ns_mcrypt init $td "keyword"
set txt [ns_mcrypt decrypt -in hex -out str $td $txt]
ns_mcrypt flush $td 
ns_mcrypt destroy $td
puts "decrypt text: $txt"

