/*
 *    Copyright (C) 2006 Richard Kotal
 *
 *    This library is free software; you can redistribute it and/or modify it 
 *    under the terms of the GNU Library General Public License as published 
 *    by the Free Software Foundation; either version 2 of the License, or 
 *    (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this library; if not, write to the
 *    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *    Boston, MA 02111-1307, USA.
 */




#include "config.h"
#if defined(NO_AOLSERVER)
#include "inc.uuencode.c"
#endif
#include "inc.crypt.c"
#include "inc.tcl.c"
#include "inc.utils.c"



#if !defined(NO_AOLSERVER)
int
Ns_ModuleInit (char *hServer, char *hModule)
{
  return Ns_TclInitInterps (hServer, ns_mcrypt_TclInterpInit, NULL);
}
#endif

int Nsmcrypt_Init (Tcl_Interp *interp)
{
#ifdef USE_TCL_STUBS
  if (Tcl_InitStubs(interp, "8.1", 0) == NULL) return TCL_ERROR;
  
#endif
    if (Tcl_PkgProvide(interp, PKG_NAME, PKG_VERSION) != TCL_OK) return TCL_ERROR;
    return ns_mcrypt_TclInterpInit (interp, NULL);
}

